
    const charSet = 'abcdefghijklmnopqrstuvwxyz';
    const specialCharSet = '!@#$%^&*()_-+=<>?/{}~';
    const numSet = '0123456789';

    document.getElementById('passwordForm').addEventListener('submit', function (event) {
      event.preventDefault();
      const passwordLength = parseInt(document.getElementById('length').value);
      const includeSpecialChars = document.getElementById('specialChars').checked;
      const includeNumbers = document.getElementById('includeNumbers').checked;
      const textTransform = document.getElementById('textTransform').value;
      const totalPasswords = parseInt(document.getElementById('totalPasswords').value);

     let validCharSet = charSet;

        if (includeSpecialChars) {
          validCharSet += specialCharSet;
        }
        
        if (includeNumbers) {
          validCharSet += numSet;
        }
        
        if (textTransform === 'uppercase') {
          validCharSet = validCharSet.toUpperCase();
        } else if (textTransform === 'lowercase') {
          validCharSet = validCharSet.toLowerCase();
        } else if (textTransform === 'mix') {
          const uppercaseCharSet = charSet.toUpperCase();
          validCharSet += uppercaseCharSet;
        }

      let generatedPasswordsHTML = '';
      for (let p = 0; p < totalPasswords; p++) {
        let generatedPassword = '';
        for (let i = 0; i < passwordLength; i++) {
          const randomIndex = Math.floor(Math.random() * validCharSet.length);
          generatedPassword += validCharSet[randomIndex];
        }

        generatedPasswordsHTML += `
          <div class="col-12 col-md-4 mb-3">
            <div class="card">
              <div class="card-body d-flex justify-content-between">
                <h5 class="card-title">${generatedPassword}</h5>
                <button class="btn btn-primary" onclick="copyPassword('${generatedPassword}')">Copy</button>
              </div>
            </div>
          </div>`;
      }

      const generatedPasswordsDiv = document.getElementById('generatedPasswords');
      generatedPasswordsDiv.innerHTML = generatedPasswordsHTML;

      // Show "Copy All" button if more than one password
      const copyAllBtn = document.getElementById('copyAllBtn');
      if (totalPasswords > 1) {
        copyAllBtn.style.display = 'block';
      } else {
        copyAllBtn.style.display = 'none';
      }
    });

    function copyPassword(password) {
      const textarea = document.createElement('textarea');
      textarea.value = password;
      document.body.appendChild(textarea);
      textarea.select();
      document.execCommand('copy');
      document.body.removeChild(textarea);
    }

    document.getElementById('copyAllBtn').addEventListener('click', function() {
      const passwords = document.querySelectorAll('#generatedPasswords h5.card-title');
      const allPasswords = Array.from(passwords).map(element => element.textContent).join('\n');
      copyPassword(allPasswords);
      this.textContent = 'All Copied!';
    });
