
       document.getElementById('calendarForm').addEventListener('submit', function (event) {
            event.preventDefault(); // Prevent form submission (prevents page refresh)

            const year = parseInt(document.getElementById('yearInput').value);
            const weekStartDay = parseInt(document.getElementById('weekStartDay').value);

            if (!isNaN(year) && year >= 1900 && year <= 9999) {
                const calendarContainer = document.getElementById('calendarContainer');
                const calendarHTML = generateCalendar(year, weekStartDay);

                // Set the generated calendar and the "Print Calendar" button inside the calendarContainer
                calendarContainer.innerHTML = calendarHTML + '<button type="button" class="btn btn-secondary submit_button" id="printButton" onclick="printDiv()">Print Calendar</button>';
            } else {
                alert('Please enter a valid year between 1900 and 9999.');
            }
        });
        

    function generateCalendar(year, weekStartDay) {
        const months = [
            'January', 'February', 'March', 'April', 'May', 'June',
            'July', 'August', 'September', 'October', 'November', 'December'
        ];

        // Reorder the days of the week based on the selected week start day
        const daysOfWeek = ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'];
        const reorderedDays = [
            ...daysOfWeek.slice(weekStartDay),
            ...daysOfWeek.slice(0, weekStartDay)
        ];

        let calendarHTML = '';
        for (let month = 0; month < 12; month++) {
            const monthName = months[month];
            const daysInMonth = new Date(year, month + 1, 0).getDate();
            const firstDay = new Date(year, month, 1).getDay();
            const offset = (firstDay - weekStartDay + 7) % 7;

            calendarHTML += '<div class="calendar-month">';
            calendarHTML += `<h4>${monthName} ${year}</h4>`;
            calendarHTML += '<table>';
            calendarHTML += `<tr>${reorderedDays.map(day => `<th>${day}</th>`).join('')}</tr>`;

            let dayCount = 1;
            let row = '<tr>';
            let columnIndex = 0;

            for (let i = 0; i < 42; i++) {
                if (columnIndex === 7) {
                    calendarHTML += row;
                    row = '<tr>';
                    columnIndex = 0;
                }

                if (i < offset || dayCount > daysInMonth) {
                    row += '<td></td>';
                } else {
                    row += `<td>${dayCount}</td>`;
                    dayCount++;
                }

                columnIndex++;
            }

            row += '</tr>';
            calendarHTML += row;
            calendarHTML += '</table>';
            calendarHTML += '</div>';
        }

        return calendarHTML;
    }
    
     
  
        function printDiv() {
        var divContents = document.getElementById("calendarContainer").innerHTML;
        var a = window.open('', '', 'height=500, width=500');
        a.document.write('<html>');
        a.document.write('<head><title>Print Calendar</title>');
        a.document.write('');
        a.document.write('<style>');
        a.document.write('table { width: 100%; border-collapse: collapse; }');
        a.document.write('th, td { border: 1px solid #ccc; text-align: center; padding: 5px; }');
        a.document.write('th { background-color: #f0f0f0; }');
        a.document.write('tr:nth-child(even) td { background-color: #f9f9f9; }');
        a.document.write('@media (max-width: 992px) { .calendar-month { flex: 0 0 100%; } }');
        a.document.write('</style></head>');
        a.document.write('<body>');
        a.document.write('<div class="container">');
        a.document.write('<h1 class="display-4" style="text-align:center;">Calendar</h1>');
        a.document.write('<div id="calendarContainer">');
        a.document.write(divContents);
        a.document.write('</div></div></body></html>');
        a.document.close();
        a.print();
    }
    