
   <?php
error_reporting(E_ALL);
ini_set('display_errors', true);

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $extension = $_POST['extension'];

    if (empty($extension)) {
        $response = array(
            'success' => false,
            'message' => 'Please select an extension.'
        );
        echo json_encode($response);
        exit;
    }

    $uploadedFiles = $_FILES['image'];
    $urls = array();

    foreach ($uploadedFiles['tmp_name'] as $key => $tmpName) {
        $fileName = $uploadedFiles['name'][$key];
        $fileExtension = pathinfo($fileName, PATHINFO_EXTENSION);
        $randomNumber = mt_rand(100000, 999999); // Generate a random 6-digit number
        $destinationPath = 'output/' . pathinfo($fileName, PATHINFO_FILENAME) . '-' . $randomNumber . '.' . $extension;

        if (!in_array($fileExtension, array('jpg', 'jpeg', 'png', 'gif'))) {
            $response = array(
                'success' => false,
                'message' => 'Invalid file format. Please upload JPG, JPEG, PNG, or GIF files for conversion.'
            );
            echo json_encode($response);
            exit;
        }

        if (move_uploaded_file($tmpName, $destinationPath)) {
            // Convert the image to PDF using GD
            convertImageToPDF($destinationPath, $extension);

            $urls[] = $destinationPath;
        } else {
            $response = array(
                'success' => false,
                'message' => 'Error uploading file ' . $fileName . '.'
            );
            echo json_encode($response);
            exit;
        }
    }

    $response = array(
        'success' => true,
        'urls' => $urls
    );
    echo json_encode($response);
    exit;
}

// Function to convert an image to PDF using GD
function convertImageToPDF($imagePath, $extension)
{
    // Load the image based on the extension
    switch ($extension) {
        case 'jpg':
        case 'jpeg':
            $image = imagecreatefromjpeg($imagePath);
            break;
        case 'png':
            $image = imagecreatefrompng($imagePath);
            break;
        case 'gif':
            $image = imagecreatefromgif($imagePath);
            break;
        default:
            return; // Invalid extension, do not proceed with conversion
    }

    // Create a new PDF document
    $pdf = new FPDF();
    $pdf->AddPage();

    // Get the image dimensions
    $width = imagesx($image);
    $height = imagesy($image);

    // Calculate the dimensions to fit the image on the page while maintaining the aspect ratio
    $pageWidth = $pdf->GetPageWidth() - $pdf->lMargin - $pdf->rMargin;
    $pageHeight = $pdf->GetPageHeight() - $pdf->tMargin - $pdf->bMargin;

    $imageWidth = $pageWidth;
    $imageHeight = $height * ($pageWidth / $width);

    if ($imageHeight > $pageHeight) {
        $imageWidth = $width * ($pageHeight / $height);
        $imageHeight = $pageHeight;
    }

    // Calculate the position to center the image on the page
    $x = ($pageWidth - $imageWidth) / 2;
    $y = ($pageHeight - $imageHeight) / 2;

    // Add the image to the PDF
    $pdf->Image($imagePath, $pdf->lMargin + $x, $pdf->tMargin + $y, $imageWidth, $imageHeight);

    // Output the PDF as a file
    $outputPath = 'output/' . pathinfo($imagePath, PATHINFO_FILENAME) . '.pdf';
    $pdf->Output($outputPath, 'F');
}
?>

<?php
$folderPath = 'output'; 


$currentTimestamp = time();


$oneHourAgo = strtotime('-1 hour');


$files = scandir($folderPath);


foreach ($files as $file) {
  if ($file !== '.' && $file !== '..') {
    $filePath = $folderPath . '/' . $file;

  
    if (is_file($filePath) && in_array(pathinfo($file, PATHINFO_EXTENSION), ['jpg', 'jpeg', 'png', 'gif', 'bmp', 'gif', 'heic', 'ico', 'svg', 'tiff', 'webp'])) {
      $fileTimestamp = filemtime($filePath);

  
      if ($fileTimestamp < $oneHourAgo) {
        
        unlink($filePath);
      }
    }
  }
}
?>
<?php include"header.php"?>
<?php include"nav.php"?>

 
  
  <div class="container" style="background: rgb(255 255 255 / 90%);padding: 18px;
">
    <div class="row">
      <div class="col-md-6 mx-auto">
        <h2 style="text-align: center;">Multi Image Converter</h2>
        <!-- <p style="text-align: center;">Convert your images to different formats</p> -->
        
        <div id="dropzone">
          <p>Drag and drop image files here</p>
          <form id="fileForm" method="post" enctype="multipart/form-data">
            <input type="file" id="fileInput" name="image[]" style="display: none;" accept="image/*" multiple>
          </form>
          <button class="btn btn-primary" id="browse" onclick="document.getElementById('fileInput').click()">Browse Files</button>
        </div>
        
        <div id="process-list"></div>
        
        <div class="d-flex">
          <select class="form-select me-3" id="extension">
            <option value="">Select an extension</option>
            <option value="bmp">BMP</option>
            <option value="gif">GIF</option>
            <option value="heic">HEIC</option>
            <option value="ico">ICO</option>
            <option value="svg">SVG</option>
            <option value="tiff">TIFF</option>
            <option value="webp">WEBP</option>
          </select>
          <button class="btn btn-primary" id="convert" disabled>Convert</button>
        </div>
        
        <br>
        
        <div id="progress-bar" class="progress" style="display: none;">
          <div id="progress-bar-inner" class="progress-bar" role="progressbar" style="width: 0;"></div>
        </div>
        
        <div id="result"></div>
        
        <div style="display: flex; justify-content: space-between;">
          <button class="btn btn-primary" id="download" style="display: none;">Download All</button>
          <button class="btn btn-primary" id="download-zip" style="display: none;">Download Zip</button>
        </div><br><br>
      </div>
    </div>
  </div>
  

<?php include"includes/ad_header.php"?>

<?php include"more_tools.php"?>

    </div>
  
  <div class="container" id="faq">
  <?php include"mostafa-content.php"?>
</div>
<?php include"footer.php"?>
 <script src="https://cdnjs.cloudflare.com/ajax/libs/dropzone/5.9.2/min/dropzone.min.js"></script>
 
 <script>
  var dropzone = document.getElementById('dropzone');
  var resultDiv = document.getElementById('result');
  var downloadButton = document.getElementById('download');
  var downloadButtonZip = document.getElementById('download-zip');
  var extensionSelect = document.getElementById('extension');
  var convertButton = document.getElementById('convert');
  var fileInput = document.getElementById('fileInput');
  var processList = document.getElementById('process-list');
  var selectedExtension = '';
  var selectedFiles = [];
  var allowedExtensions = ['jpg', 'jpeg', 'png', 'gif']; // Add more allowed extensions if needed

  dropzone.addEventListener('dragover', function(e) {
    e.preventDefault();
    dropzone.style.border = '2px dashed #aaa';
  });

  dropzone.addEventListener('dragleave', function() {
    dropzone.style.border = '2px dashed #ccc';
  });

  dropzone.addEventListener('drop', function(e) {
    e.preventDefault();
    dropzone.style.border = '2px dashed #ccc';
    resultDiv.innerHTML = '';
    downloadButton.style.display = 'none';
    downloadButtonZip.style.display = 'none';

    var files = e.dataTransfer.files;
    displaySelectedFiles(files);
  });

  extensionSelect.addEventListener('change', function() {
    selectedExtension = extensionSelect.value;
    if (selectedExtension === '') {
      convertButton.disabled = true;
    } else {
      convertButton.disabled = false;
    }
  });

  fileInput.addEventListener('change', function() {
    var files = fileInput.files;
    displaySelectedFiles(files);
  });

  processList.style.maxHeight = '0';
processList.style.overflowY = 'hidden';

function displaySelectedFiles(files) {
  if (files.length === 0) {
    alert('Please select image file(s).');
    return;
  }

    for (var i = 0; i < files.length; i++) {
      var file = files[i];
      var fileExtension = getFileExtension(file.name);

      if (!allowedExtensions.includes(fileExtension.toLowerCase())) {
        alert('Invalid extension. Skipping file: ' + file.name);
        continue;
      }

     selectedFiles.push(file);
var listItem = document.createElement('div');
listItem.classList.add('selected-item', 'd-flex', 'align-items-center');
listItem.innerHTML = `
  <div class="thumbnail-container me-2">
    <img src="${URL.createObjectURL(file)}" class="thumbnail" alt="Thumbnail" style="width:80px;height:40px;padding:5px;">
  </div>
  <div>
    <p class="mb-1">${file.name}</p>
    <p class="mb-0" style="font-size:12px;color:#7a7c7e">${formatBytes(file.size)}</p>
  </div>
  <button onclick="removeSelectedFile(${i})" class="btn btn-warning btn-sm ms-auto">Remove</button>
`;
processList.appendChild(listItem);

 processList.style.maxHeight = '200px';
  processList.style.overflowY = 'scroll';
}
  }

  function removeSelectedFile(index) {
  selectedFiles.splice(index, 1);
  processList.removeChild(processList.children[index]);
  
  // Reset the index of each child element
  for (var i = index; i < processList.children.length; i++) {
    processList.children[i].querySelector('button').setAttribute('onclick', `removeSelectedFile(${i})`);
  }
}


  function convertImages() {
    if (selectedFiles.length === 0) {
      alert('Please select image file(s).');
      return;
    }

    if (selectedExtension === '') {
      alert('Please select a valid extension.');
      return;
    }

    var formData = new FormData();
    formData.append('extension', selectedExtension);

    for (var i = 0; i < selectedFiles.length; i++) {
      formData.append('image[]', selectedFiles[i]);
    }

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '<?php echo $_SERVER["PHP_SELF"]; ?>', true);

    // Track upload progress
    xhr.upload.addEventListener('progress', function(event) {
      if (event.lengthComputable) {
        var percentComplete = (event.loaded / event.total) * 100;
        updateProgressBar(percentComplete);
      }
    });

    xhr.onreadystatechange = function() {
      if (xhr.readyState === XMLHttpRequest.DONE) {
        hideProgressBar(); // Hide the progress bar once the request is complete

 if (xhr.status === 200) {
  var response = JSON.parse(xhr.responseText);
  if (response.success) {
    resultDiv.innerHTML = '';
    downloadButton.style.display = 'block';
    downloadButtonZip.style.display = 'block';
    var urls = response.urls;
    var extensionGroups = groupImagesByExtension(urls);
    for (var ext in extensionGroups) {
      var images = extensionGroups[ext];
      var extDiv = document.createElement('div');
      extDiv.className = 'col-md-12 mb-4';
      var rowDiv = document.createElement('div');
      rowDiv.className = 'row g-4';
      for (var i = 0; i < images.length; i++) {
        var imgDiv = document.createElement('div');
        imgDiv.className = 'col-md-2';
        var img = document.createElement('img');
        img.src = images[i];
        img.className = 'thumbnail w-100';
        var fileName = getFileNameFromUrl(images[i]);
        var nameDiv = document.createElement('div');
        nameDiv.className = 'conv-img-title';
        nameDiv.innerText = fileName;
        imgDiv.appendChild(img);
        imgDiv.appendChild(nameDiv);
        rowDiv.appendChild(imgDiv);
      }
      extDiv.appendChild(rowDiv);
      resultDiv.appendChild(extDiv);
    }
    // Show success message
    var successMessage = document.createElement('div');
    successMessage.className = 'alert alert-success mt-4';
    successMessage.innerText = 'Conversion successful!';
    resultDiv.appendChild(successMessage);

    // Show note message
    var noteMessage = document.createElement('div');
    noteMessage.className = 'alert alert-danger mt-2';
    noteMessage.innerText = 'Note: These images will be deleted in 1 hour.';
    resultDiv.appendChild(noteMessage);
  } else {
    resultDiv.innerHTML = response.message;
    downloadButton.style.display = 'none';
    downloadButtonZip.style.display = 'none';
  }
} else {
  resultDiv.innerHTML = 'Error occurred during conversion. Please try again later.';
  downloadButton.style.display = 'none';
  downloadButtonZip.style.display = 'none';
}


      }
    };

    // Show the progress bar
    showProgressBar();

    xhr.send(formData);
  }

  function getFileNameFromUrl(url) {
    var parts = url.split('/');
    return parts[parts.length - 1];
  }

  function showProgressBar() {
    var progressBar = document.getElementById('progress-bar');
    progressBar.style.display = 'block';
  }

  function hideProgressBar() {
    var progressBar = document.getElementById('progress-bar');
    progressBar.style.display = 'none';
  }

  function updateProgressBar(percentComplete) {
    var progressBarInner = document.getElementById('progress-bar-inner');
    progressBarInner.style.width = percentComplete + '%';
    progressBarInner.innerText = percentComplete.toFixed(1) + '%';
  }

  function formatBytes(bytes, decimals = 2) {
    if (bytes === 0) return '0 Bytes';
    var k = 1024;
    var dm = decimals < 0 ? 0 : decimals;
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
    var i = Math.floor(Math.log(bytes) / Math.log(k));
        return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
  }

  function groupImagesByExtension(images) {
    var extensionGroups = {};
    for (var i = 0; i < images.length; i++) {
      var img = images[i];
      var ext = img.substr(img.lastIndexOf('.') + 1);
      if (!extensionGroups[ext]) {
        extensionGroups[ext] = [];
      }
      extensionGroups[ext].push(img);
    }
    return extensionGroups;
  }

  convertButton.addEventListener('click', convertImages);

  downloadButton.addEventListener('click', function() {
    var images = resultDiv.querySelectorAll('img');
    for (var i = 0; i < images.length; i++) {
      var img = images[i];
      var link = document.createElement('a');
      link.href = img.src;
      link.download = img.src.substr(img.src.lastIndexOf('/') + 1);
      link.click();
    }
  });

  function getFileExtension(filename) {
    return filename.split('.').pop();
  }
</script>

<script>
var downloadAllButton = document.getElementById('download-zip');
downloadAllButton.addEventListener('click', downloadAllImages);

function downloadAllImages() {
  var images = resultDiv.querySelectorAll('img');
  if (images.length === 0) {
    alert('No images to download.');
    return;
  }

  var zip = new JSZip();
  var promises = [];

  for (var i = 0; i < images.length; i++) {
    (function() {
      var img = images[i];
      var url = img.src;
      var fileName = getFileNameFromUrl(url);
      var dataPromise = fetch(url)
        .then(function(response) {
          return response.blob();
        })
        .then(function(blob) {
          zip.file(fileName, blob);
        });

      promises.push(dataPromise);
    })();
  }

  Promise.all(promises)
    .then(function() {
      return zip.generateAsync({ type: 'blob' });
    })
    .then(function(content) {
      var link = document.createElement('a');
      link.href = URL.createObjectURL(content);
      link.download = 'converted_images.zip';
      link.click();
    })
    .catch(function(error) {
      console.error('Error occurred during ZIP file generation:', error);
      alert('Failed to generate ZIP file.');
    });
}

</script>

<script>
  // Check if the ad is hidden
  var ad = document.getElementById('testAd');
  var adblockDetected = ad === null || ad.offsetParent === null;

  if (adblockDetected) {
    // Adblocker detected, show overlay
    document.querySelector('.adblock-overlay').style.display = 'block';

    // Add click event listener to overlay to hide it when clicked
    document.querySelector('.adblock-overlay').addEventListener('click', function () {
      if (adblockDetected) {
        return; // Adblocker still detected, do nothing
      }
      this.style.display = 'none'; // Adblocker disabled, hide overlay
    });
  }
</script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.7.1/jszip.min.js"></script>
<!-- Bootstrap JS -->
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>

</body>

</html>
