
<?php include"header.php"?>
<?php include"nav.php"?>
 
<style>
    input {
        margin-bottom:10px;
    }
    .error-message {
        color:red;
    }
</style>

<?php
function isInternalLink($url, $base_url) {
    $url_parts = parse_url($url);
    $base_url_parts = parse_url($base_url);

    if (isset($url_parts['host']) && $url_parts['host'] === $base_url_parts['host']) {
        return true;
    }

    if (!isset($url_parts['host']) && isset($url_parts['path'])) {
        return true;
    }

    return false;
}

function makeAbsoluteUrl($relativeUrl, $baseUrl) {
    $baseParts = parse_url($baseUrl);
    $path = ltrim($relativeUrl, '/');

    if (empty($baseParts['path']) || substr($baseParts['path'], -1) !== '/') {
        $baseParts['path'] .= '/';
    }

    return $baseParts['scheme'] . '://' . $baseParts['host'] . $baseParts['path'] . $path;
}

function extractInternalUrls($url, &$urlCount) {
    $html = file_get_contents($url);

    if ($html === false) {
        die('Failed to fetch the URL.');
    }

    $dom = new DOMDocument;
    libxml_use_internal_errors(true);
    $dom->loadHTML($html);
    libxml_clear_errors();

    $internalUrls = [];

    $links = $dom->getElementsByTagName('a');

    foreach ($links as $link) {
        $href = $link->getAttribute('href');

        if (empty($href)) {
            continue;
        }

        if (isInternalLink($href, $url)) {
            if (!isset(parse_url($href)['host'])) {
                $href = makeAbsoluteUrl($href, $url);
            }

            $internalUrls[] = $href;
        }
    }

    $internalUrls = array_unique($internalUrls);

    $urlCount += count($internalUrls);

    return $internalUrls;
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $indexPageUrl = $_POST['url'];
    $urlCount = 0;

    if (!empty($indexPageUrl) && filter_var($indexPageUrl, FILTER_VALIDATE_URL)) {
        $internalUrls = extractInternalUrls($indexPageUrl, $urlCount);

        $outputFolder = 'output/';
        if (!file_exists($outputFolder)) {
            mkdir($outputFolder, 0777, true);
        }

        $sitemap = new DOMDocument('1.0', 'UTF-8');
        $sitemap->formatOutput = true;

        $urlset = $sitemap->createElement('urlset');
        $urlset->setAttribute('xmlns', 'http://www.sitemaps.org/schemas/sitemap/0.9');
        $sitemap->appendChild($urlset);

        $freqOptions = ['always', 'hourly', 'daily', 'weekly', 'monthly', 'yearly', 'never'];
        $defaultFreq = 'monthly';
        $defaultPriority = '0.8000';

        foreach ($internalUrls as $url) {
            $urlElement = $sitemap->createElement('url');
            $locElement = $sitemap->createElement('loc', htmlspecialchars($url));

            $changefreqElement = $sitemap->createElement('changefreq', $_POST['frequency'] ?? $defaultFreq);
            $priorityElement = $sitemap->createElement('priority', $_POST['priority'] ?? $defaultPriority);
            $lastmodElement = $sitemap->createElement('lastmod', $_POST['last_modified'] ?? '');

            $urlElement->appendChild($locElement);
            $urlElement->appendChild($changefreqElement);
            $urlElement->appendChild($priorityElement);
            $urlElement->appendChild($lastmodElement);

            $urlset->appendChild($urlElement);
        }

        $uniqueId = substr(str_shuffle('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'), 0, 4);

        $filename = $outputFolder . 'sitemap_' . date('YmdHis') . '_' . $uniqueId . '.xml';
        $sitemap->save($filename);

        $reportDateTime = date('Y-m-d H:i:s');

        $successMessage = 'Sitemap generated successfully.';
    } else {
        $errorMessage = 'Please enter a valid URL.';
    }
}
?>

<div class="container" style="background: rgb(255 255 255 / 90%);padding: 18px;">
    <div class="col-md-6 mx-auto">
           <h2 style="text-align: center;">Sitemap Generator</h2>
        <!-- <p style="text-align: center;">Sitemap Generator: Easily create and view sitemaps for your website.</p> -->
    <div class="row">
            <form action="" method="post">
            <div class="form-group">
                <label for="url">Enter a URL:</label>
                <input type="url" class="form-control" name="url" id="url" placeholder="https://example.com" required>
            </div>
            <div class="form-group">
                <label for="frequency">Change Frequency:</label>
                <select class="form-control" name="frequency" id="frequency">
                    <option value="always">Always</option>
                    <option value="hourly">Hourly</option>
                    <option value="daily">Daily</option>
                    <option value="weekly">Weekly</option>
                    <option value="monthly" selected="selected">Monthly</option>
                    <option value="yearly">Yearly</option>
                    <option value="never">Never</option>
                </select>
            </div>
            <div class="form-group">
                <label for="priority">Priority:</label>
                <input type="number" class="form-control" name="priority" id="priority" step="0.1" min="0" max="1" value="0.8">
            </div>
            <div class="form-group">
                <label for="last_modified">Last Modified:</label>
                <select class="form-control" name="last_modified" id="last_modified">
                    <option value="">None</option>
                    <option value="<?php echo date('c'); ?>">Current Time</option>
                    <option value="Server's Response">Server's Response</option>
                </select>
            </div>
        <div class="center-button">
            <button type="submit" name="submit" class="btn btn-success submit_button">Generate Sitemap</button>
        </div><br>
        </form>
        <div id="errorMessages" class="error-message"></div>
         <?php if (isset($successMessage)) : ?>
    <div class="alert alert-success">
        <center><p><?php echo $successMessage; ?></p>
        <p>Total URLs generated: <b><?php echo $urlCount; ?></b></p>
        <p>Generated on : <b><?php echo $reportDateTime; ?></b></p></center>
        
    </div>
    <a href="<?php echo htmlspecialchars($filename)?>" class="btn btn-primary"  target="blank">Download Sitemap</a>
<?php endif; ?>

                    </div>
</div></div>


    </div>
 <?php include"more_tools.php"?>
  
</div>
</div>

 </div>
    </div>
  </div>

    </div>
 

  <div class="container" id="faq">
  <?php include"mostafa-content.php"?>
</div>
<?php include"footer.php"?>


    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
 
</body>
</html>
